
AnimatedParts = {};

AnimatedParts.modDir = g_currentModDirectory;

function AnimatedParts.prerequisitesPresent(specializations)
    return true; 
end;

function AnimatedParts:load(savegame)
	-- Initialize our cabinControl object(?)(table?)
	self.AParts = {};
	-- Check joystick node
	self.AParts.joystick = {};
	self.AParts.joystick.node = Utils.indexToObject( self.components, getXMLString(self.xmlFile, "vehicle.AnimatedParts.joystick#node") );
	
	if self.AParts.joystick.node ~= nil then
		self.AParts.joystick.rotF = math.rad( Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.AnimatedParts.joystick#rotFront"), 0) );
		self.AParts.joystick.rotB = math.rad( Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.AnimatedParts.joystick#rotBack"), 0) );
		self.AParts.joystick.rotT = 0;
		self.AParts.joystick.rotC = 0;
		
		self.AParts.joystick.lastSpeedTarget = 999;
		self.AParts.joystick.limiterReached = true;
		self.AParts.joystick.direction = 1; -- DO NOT CHANGE THIS!
	end;
	
	
	-- Check shuttle node
	self.AParts.shuttle = {};
	self.AParts.shuttle.node = Utils.indexToObject( self.components, getXMLString(self.xmlFile, "vehicle.AnimatedParts.shuttle#node") );
	
	if self.AParts.shuttle.node ~= nil then
		--Forward position
		self.AParts.shuttle.rotFwd = {0, 0, 0};
		local rx, ry, rz = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.AnimatedParts.shuttle#rotFwd"));
		if rx ~= nil and ry ~= nil and rz ~= nil then
			self.AParts.shuttle.rotFwd = {math.rad(rx), math.rad(ry), math.rad(rz)};
		end;
		--Backward position
		self.AParts.shuttle.rotBwd = {0, 0, 0};
		rx, ry, rz = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.AnimatedParts.shuttle#rotBwd"));
		if rx ~= nil and ry ~= nil and rz ~= nil then
			self.AParts.shuttle.rotBwd = {math.rad(rx), math.rad(ry), math.rad(rz)};
		end;
		--Neutral/handbrake position
		self.AParts.shuttle.rotNeut = {0, 0, 0};
		rx, ry, rz = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.AnimatedParts.shuttle#rotNeut"));
		if rx ~= nil and ry ~= nil and rz ~= nil then
			self.AParts.shuttle.rotNeut = {math.rad(rx), math.rad(ry), math.rad(rz)};
		end;
	end;
	
	-- Check handThrottle node
	self.AParts.handThrottle = {};
	self.AParts.handThrottle.node = Utils.indexToObject( self.components, getXMLString(self.xmlFile, "vehicle.AnimatedParts.handthrottle#node") );
	
	if self.AParts.handThrottle.node ~= nil then
		self.AParts.handThrottle.rotMinX = math.rad( Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.AnimatedParts.handthrottle#rotMinX"), 0) );
		self.AParts.handThrottle.rotMaxX = math.rad( Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.AnimatedParts.handthrottle#rotMaxX"), 0) );
	end;
	
	
	--Check brake node
	self.AParts.pedals = {};
	self.AParts.pedals.rotSpeed = 0.00125;
	self.AParts.brake = {};
	self.AParts.brake.node = Utils.indexToObject( self.components, getXMLString(self.xmlFile, "vehicle.AnimatedParts.brake#node") );
	
	if self.AParts.brake.node ~= nil then
		self.AParts.brake.rotMinX = math.rad( Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.AnimatedParts.brake#rotMinX"), 0) );
		self.AParts.brake.rotMaxX = math.rad( Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.AnimatedParts.brake#rotMaxX"), 0) );
	end;
	--Check clutch node
	self.AParts.clutch = {};
	self.AParts.clutch.node = Utils.indexToObject( self.components, getXMLString(self.xmlFile, "vehicle.AnimatedParts.clutch#node") );
	
	if self.AParts.clutch.node ~= nil then
		self.AParts.clutch.rotMinX = math.rad( Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.AnimatedParts.clutch#rotMinX"), 0) );
		self.AParts.clutch.rotMaxX = math.rad( Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.AnimatedParts.clutch#rotMaxX"), 0) );
	end;
	--Check throttle node
	self.AParts.throttle = {};
	self.AParts.throttle.node = Utils.indexToObject( self.components, getXMLString(self.xmlFile, "vehicle.AnimatedParts.throttle#node") );
	
	if self.AParts.throttle.node ~= nil then
		self.AParts.throttle.rotMinX = math.rad( Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.AnimatedParts.throttle#rotMinX"), 0) );
		self.AParts.throttle.rotMaxX = math.rad( Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.AnimatedParts.throttle#rotMaxX"), 0) );
	end;
	
	
	--Check implement node
	self.AParts.implement = {};
	self.AParts.implement.node = Utils.indexToObject( self.components, getXMLString(self.xmlFile, "vehicle.AnimatedParts.implement#node") );
	
	if self.AParts.implement.node ~= nil then
		self.AParts.implement.rotMinX = math.rad( Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.AnimatedParts.implement#rotMinX"), 0) );
		self.AParts.implement.rotMaxX = math.rad( Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.AnimatedParts.implement#rotMaxX"), 0) );
		
		
		self.AParts.implement.rotSpeed = 0.00125;
		self.AParts.implement.isRaised = 1;
		self.AParts.implement.reachedTarget = false;
		local rx, ry, rz = getRotation(self.AParts.implement.node);
		self.AParts.implement.defRotation = rx;
		self.AParts.implement.currRotation = rx;
		self.AParts.implement.maxRot = self.AParts.implement.rotMaxX - self.AParts.implement.rotMinX;
	end;

	--Front
	self.AParts.implement1 = {};
	self.AParts.implement1.node = Utils.indexToObject( self.components, getXMLString(self.xmlFile, "vehicle.AnimatedParts.implement1#node") );
	
	if self.AParts.implement1.node ~= nil then
		self.AParts.implement1.rotMinX = math.rad( Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.AnimatedParts.implement1#rotMinX"), 0) );
		self.AParts.implement1.rotMaxX = math.rad( Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.AnimatedParts.implement1#rotMaxX"), 0) );
		
		
		self.AParts.implement1.rotSpeed = 0.00125;
		self.AParts.implement1.isRaised = 1;
		self.AParts.implement1.reachedTarget = false;
		local rx, ry, rz = getRotation(self.AParts.implement1.node);
		self.AParts.implement1.defRotation = rx;
		self.AParts.implement1.currRotation = rx;
		self.AParts.implement1.maxRot = self.AParts.implement.rotMaxX - self.AParts.implement.rotMinX;
	end;
end;

function AnimatedParts:delete()

end;

function AnimatedParts:readStream(streamId, connection)
end;

function AnimatedParts:writeStream(streamId, connection)
end;

function AnimatedParts:mouseEvent(posX, posY, isDown, isUp, button)
end;

function AnimatedParts:keyEvent(unicode, sym, modifier, isDown)
end;

function AnimatedParts:update(dt)
	if self:getIsActive() then
		if self.isClient then
		
			--Joystick
			if self.AParts.joystick.node then
				AnimatedParts.updateJoystick(self, dt);
			end;
			
			--Shuttle
			local isOn = false;
			if self.mrGbMS ~= nil then
				isOn = self:mrGbMGetIsOnOff();
			end;
			if isOn then
				AnimatedParts.updateShuttleMrGbMS(self);
				AnimatedParts.updatePedalsMrGbMS(self, dt);
			elseif self.driveControl and self.driveControl.shuttle.isActive then
				AnimatedParts.updateShuttleDC(self);
				AnimatedParts.updatePedalsDC(self, dt);
			else
				AnimatedParts.updateShuttle(self);
				AnimatedParts.updatePedals(self, dt);
			end
			
			--HandThrottle
			if self.AParts.handThrottle.node and self.mrGbMS ~= nil then
				AnimatedParts.updateHandThrottle(self, dt);
			end;
			
			
			--Pedals
			--if self.AParts.brake.node and self.AParts.clutch.node and self.AParts.throttle.node then
				--AnimatedParts.updatePedals(self, dt);
			--end;
			
			
			--Implement
			if self.AParts.implement.node then
				AnimatedParts.updateImplement(self, dt);
			end;
		end;
	end;
	
	if self.motor.speedLevel ~= 0 then
	end;
	
end;

function AnimatedParts:updateTick(dt)

end;

function AnimatedParts:onLeave()
end;

function AnimatedParts:draw()
end;

-- Joystick --
function AnimatedParts.updateJoystick(self, dt)
	local axisAccelerate = 0 --InputBinding.getDigitalInputAxis(InputBinding.AXIS_ACCELERATE_VEHICLE); 
	local axisBrake = 0 --InputBinding.getDigitalInputAxis(InputBinding.AXIS_BRAKE_VEHICLE) 
	local axisForward = 0 --Utils.clamp((axisAccelerate-axisBrake)*0.5, -1, 1); 
	
	axisAccelerate = InputBinding.getDigitalInputAxis(InputBinding.AXIS_ACCELERATE_VEHICLE);
	axisBrake = InputBinding.getDigitalInputAxis(InputBinding.AXIS_BRAKE_VEHICLE)
	axisForward = Utils.clamp((axisAccelerate-axisBrake)*0.5, -1, 1);
	if InputBinding.isAxisZero(axisForward) then 
		axisAccelerate = InputBinding.getAnalogInputAxis(InputBinding.AXIS_ACCELERATE_VEHICLE); 
		axisBrake = InputBinding.getAnalogInputAxis(InputBinding.AXIS_BRAKE_VEHICLE) 
		axisForward = Utils.clamp((axisAccelerate-axisBrake)*0.5, -1, 1); 
	end
	
	local currSpeed = self.lastSpeed*3600;
	
	-- Speed limiter changed.
	if self.AParts.joystick.lastSpeedTarget ~= self.cruiseControl.speed and self.cruiseControl.state == Drivable.CRUISECONTROL_STATE_ACTIVE then
		self.AParts.joystick.limiterReached = false;
		self.AParts.joystick.lastSpeedTarget = self.cruiseControl.speed;
		if currSpeed < self.cruiseControl.speed then
			self.AParts.joystick.direction = -1;
		else
			self.AParts.joystick.direction = 1;
		end;
	end;
	
	if not self.AParts.joystick.limiterReached then
		axisAccelerate = self.AParts.joystick.direction;
		if self.AParts.joystick.direction == -1 and currSpeed > self.cruiseControl.speed then
			self.AParts.joystick.limiterReached = true;
		elseif self.AParts.joystick.direction == 1 and currSpeed < self.cruiseControl.speed then
			self.AParts.joystick.limiterReached = true;
		end;
	end;

	if axisAccelerate > 0 then
		self.AParts.joystick.rotT = -self.AParts.joystick.rotF*axisAccelerate;
	elseif axisBrake < 0 then
		self.AParts.joystick.rotT = self.AParts.joystick.rotB*axisBrake;
	else
		self.AParts.joystick.rotT = 0;
	end
	
	
	if self.AParts.joystick.rotC < self.AParts.joystick.rotT then
		self.AParts.joystick.rotC = self.AParts.joystick.rotC + dt/2000;
		if self.AParts.joystick.rotC > self.AParts.joystick.rotT then
			self.AParts.joystick.rotC = self.AParts.joystick.rotT;
		end;
	elseif self.AParts.joystick.rotC > self.AParts.joystick.rotT then
		self.AParts.joystick.rotC = self.AParts.joystick.rotC - dt/2000;
		if self.AParts.joystick.rotC < self.AParts.joystick.rotT then
			self.AParts.joystick.rotC = self.AParts.joystick.rotT;
		end;
	end;
	
	setRotation( self.AParts.joystick.node, self.AParts.joystick.rotC, 0, 0 );
end;

-- Shuttle --
-- GEARBOX -- 
function AnimatedParts.updateShuttleMrGbMS(self)
	if not self.AParts.shuttle.node then
		return;
	end;
	if self:mrGbMGetNeutralActive() then
		setRotation( self.AParts.shuttle.node, self.AParts.shuttle.rotNeut[1], self.AParts.shuttle.rotNeut[2], self.AParts.shuttle.rotNeut[3] );
	elseif self:mrGbMGetReverseActive() then
		setRotation( self.AParts.shuttle.node, self.AParts.shuttle.rotBwd[1], self.AParts.shuttle.rotBwd[2], self.AParts.shuttle.rotBwd[3] );
	else
		setRotation( self.AParts.shuttle.node, self.AParts.shuttle.rotFwd[1], self.AParts.shuttle.rotFwd[2], self.AParts.shuttle.rotFwd[3] );
	end;
end;
-- DRIVE CONTROL --
function AnimatedParts.updateShuttleDC(self)
	if not self.AParts.shuttle.node then
		return;
	end;
	--print(self.lastSpeed);
	if self.driveControl.shuttle.direction > 0 and self.lastSpeed > 0.0001 then
		setRotation( self.AParts.shuttle.node, self.AParts.shuttle.rotFwd[1], self.AParts.shuttle.rotFwd[2], self.AParts.shuttle.rotFwd[3] );
	elseif self.driveControl.shuttle.direction < 0 and self.lastSpeed > 0.0001 then
		setRotation( self.AParts.shuttle.node, self.AParts.shuttle.rotBwd[1], self.AParts.shuttle.rotBwd[2], self.AParts.shuttle.rotBwd[3] );
	else
		setRotation( self.AParts.shuttle.node, self.AParts.shuttle.rotNeut[1], self.AParts.shuttle.rotNeut[2], self.AParts.shuttle.rotNeut[3] );
	end;
end;
-- DEFAULT --
function AnimatedParts.updateShuttle(self)
	if not self.AParts.shuttle.node then
		return;
	end;
	--print(self.movingDirection );
	if self.movingDirection > 0.0001 then
		setRotation( self.AParts.shuttle.node, self.AParts.shuttle.rotFwd[1], self.AParts.shuttle.rotFwd[2], self.AParts.shuttle.rotFwd[3] );
	elseif self.movingDirection < -0.0001 then
		setRotation( self.AParts.shuttle.node, self.AParts.shuttle.rotBwd[1], self.AParts.shuttle.rotBwd[2], self.AParts.shuttle.rotBwd[3] );
	else
		setRotation( self.AParts.shuttle.node, self.AParts.shuttle.rotNeut[1], self.AParts.shuttle.rotNeut[2], self.AParts.shuttle.rotNeut[3] );
	end;
end;

-- HAND THROTTLE --
function AnimatedParts.updateHandThrottle(self)
	local throttle = self:mrGbMGetHandThrottle();
	local maxRot = self.AParts.handThrottle.rotMaxX - self.AParts.handThrottle.rotMinX;
	local currRotation = self.AParts.handThrottle.rotMinX + maxRot * throttle;
	--print("throttle: "..throttle);
	setRotation(self.AParts.handThrottle.node, currRotation, 0, 0 );
	

end;


-- Pedals --
-- GEARBOX -- 
function AnimatedParts.updatePedalsMrGbMS(self, dt)
	local axisAccelerate = 0 --InputBinding.getDigitalInputAxis(InputBinding.AXIS_ACCELERATE_VEHICLE); 
	local axisBrake = 0 --InputBinding.getDigitalInputAxis(InputBinding.AXIS_BRAKE_VEHICLE) 
	local axisForward = 0 --Utils.clamp((axisAccelerate-axisBrake)*0.5, -1, 1); 
	
	axisAccelerate = InputBinding.getDigitalInputAxis(InputBinding.AXIS_ACCELERATE_VEHICLE);
	axisBrake = InputBinding.getDigitalInputAxis(InputBinding.AXIS_BRAKE_VEHICLE)
	axisForward = Utils.clamp((axisAccelerate-axisBrake)*0.5, -1, 1);
	if InputBinding.isAxisZero(axisForward) then 
		axisAccelerate = InputBinding.getAnalogInputAxis(InputBinding.AXIS_ACCELERATE_VEHICLE); 
		axisBrake = InputBinding.getAnalogInputAxis(InputBinding.AXIS_BRAKE_VEHICLE) 
		axisForward = Utils.clamp((axisAccelerate-axisBrake)*0.5, -1, 1); 
	end
	
	if axisForward < 0 then
		if not self:mrGbMGetNeutralActive() then
			axisAccelerate = axisBrake * -1;
		elseif self.driveControl.isActive then
			axisAccelerate = axisBrake * -1;
		end;
	elseif axisForward > 0 then
		if not self:mrGbMGetNeutralActive() then
			axisAccelerate = axisBrake * -1;
		elseif self.driveControl.isActive then
			axisAccelerate = axisBrake * -1;
		end;
	end
	
	--if self:mrGbMGetNeutralActive() then
		--clutchAxis = 1;
	--end;
	
	AnimatedParts.setPedals(self,axisAccelerate, axisBrake, 0, dt);
end;
-- DRIVE CONTROL --
function AnimatedParts.updatePedalsDC(self, dt)
	local axisAccelerate = 0 --InputBinding.getDigitalInputAxis(InputBinding.AXIS_ACCELERATE_VEHICLE); 
	local axisBrake = 0 --InputBinding.getDigitalInputAxis(InputBinding.AXIS_BRAKE_VEHICLE) 
	local axisForward = 0 --Utils.clamp((axisAccelerate-axisBrake)*0.5, -1, 1); 
	
	axisAccelerate = InputBinding.getDigitalInputAxis(InputBinding.AXIS_ACCELERATE_VEHICLE);
	axisBrake = InputBinding.getDigitalInputAxis(InputBinding.AXIS_BRAKE_VEHICLE)
	axisForward = Utils.clamp((axisAccelerate-axisBrake)*0.5, -1, 1);
	if InputBinding.isAxisZero(axisForward) then 
		axisAccelerate = InputBinding.getAnalogInputAxis(InputBinding.AXIS_ACCELERATE_VEHICLE); 
		axisBrake = InputBinding.getAnalogInputAxis(InputBinding.AXIS_BRAKE_VEHICLE) 
		axisForward = Utils.clamp((axisAccelerate-axisBrake)*0.5, -1, 1); 
	end
	
	if self.driveControl.shuttle.direction > 0 and self.lastSpeed > 0.0001 then
		if axisForward < 0 then
			axisAccelerate = axisBrake * -1;
		end;
	elseif self.driveControl.shuttle.direction < 0 and self.lastSpeed > 0.0001 then
		if axisForward > 0 then
			axisAccelerate = axisBrake * -1;
		end;
	end;
	
	AnimatedParts.setPedals(self,axisAccelerate, axisBrake, 0, dt);
end;
-- DEFAULT --
function AnimatedParts.updatePedals(self, dt)
	local axisAccelerate = 0 --InputBinding.getDigitalInputAxis(InputBinding.AXIS_ACCELERATE_VEHICLE); 
	local axisBrake = 0 --InputBinding.getDigitalInputAxis(InputBinding.AXIS_BRAKE_VEHICLE) 
	local axisForward = 0 --Utils.clamp((axisAccelerate-axisBrake)*0.5, -1, 1); 
	
	axisAccelerate = InputBinding.getDigitalInputAxis(InputBinding.AXIS_ACCELERATE_VEHICLE);
	axisBrake = InputBinding.getDigitalInputAxis(InputBinding.AXIS_BRAKE_VEHICLE)
	axisForward = Utils.clamp((axisAccelerate-axisBrake)*0.5, -1, 1);
	if InputBinding.isAxisZero(axisForward) then 
		axisAccelerate = InputBinding.getAnalogInputAxis(InputBinding.AXIS_ACCELERATE_VEHICLE); 
		axisBrake = InputBinding.getAnalogInputAxis(InputBinding.AXIS_BRAKE_VEHICLE) 
		axisForward = Utils.clamp((axisAccelerate-axisBrake)*0.5, -1, 1); 
	end
	
	if self.movingDirection > 0.0001 then
		if axisForward < 0 then
			axisAccelerate = axisBrake * -1;
		else
			axisBrake = axisForward;
		end;
	elseif self.movingDirection < 0.0001 then
		if axisForward > 0 then
			axisAccelerate = axisBrake * -1;
		else
			axisBrake = axisForward;
	end;
	end
	AnimatedParts.setPedals(self, axisAccelerate, axisBrake, 0, dt);
end;
-- Set pedals --
function AnimatedParts.setPedals(self,axisAccelerate, axisBrake, clutchAxis, dt)
	local maxRot = 0;
	local currRotation = 0;
	local targetRot = 0;
	local cx, cy, cz;
	--brake
	if self.AParts.brake.node then
		maxRot = self.AParts.brake.rotMaxX - self.AParts.brake.rotMinX;
		targetRot = self.AParts.brake.rotMinX + maxRot * axisBrake;
		cx, cy, cz = getRotation(self.AParts.brake.node);
		local x;
		if axisBrake > 0 then
			x = cx + self.AParts.pedals.rotSpeed * dt;
			if x > targetRot then
				x = targetRot;
			end;
		else
			x = cx - self.AParts.pedals.rotSpeed * dt;
			if x < targetRot then
				x = targetRot;
			end;
		end;
			
		--if x < maxRot and x > self.AParts.brake.rotMinX then -- WARNING; 0 to -30 not 0 to 30 (inverted!)
			setRotation(self.AParts.brake.node, x, 0, 0 );
		--end;
		
	end;
	--clutch
	--if self.AParts.clutch.node then
		--maxRot = self.AParts.clutch.rotMaxX - self.AParts.clutch.rotMinX;
		--currRotation = self.AParts.clutch.rotMinX + maxRot * clutchAxis;
		--setRotation(self.AParts.clutch.node, currRotation, 0, 0 );
	--end;
	--throttle
	if self.AParts.throttle.node then
		maxRot = self.AParts.throttle.rotMaxX - self.AParts.throttle.rotMinX;
		targetRot = self.AParts.throttle.rotMinX + maxRot * axisAccelerate;
		cx, cy, cz = getRotation(self.AParts.throttle.node);
		local x;
		if axisAccelerate > 0 then
			x = cx + self.AParts.pedals.rotSpeed * dt;
			if x > targetRot then
				x = targetRot;
			end;
		else
			x = cx - self.AParts.pedals.rotSpeed * dt;
			if x < targetRot then
				x = targetRot;
			end;
		end;
			
		--if x < maxRot and x > self.AParts.throttle.rotMinX then 
			setRotation(self.AParts.throttle.node, x, 0, 0 );
		--end;
	
	
	
	
	
	
	
	
		--maxRot = self.AParts.throttle.rotMaxX - self.AParts.throttle.rotMinX;
		--currRotation = self.AParts.throttle.rotMinX + maxRot * axisForward;
		--setRotation(self.AParts.throttle.node, currRotation, 0, 0 );
	end;
end;

-- IMPLEMENT --
function AnimatedParts.updateImplement(self, dt)
	local rearAttached = false;
	for i=1, table.getn(self.attachedImplements) do
		local implement = self.attachedImplements[i];
		local object = implement.object;
		if object ~= nil then 
			local jointDescIndex = implement.jointDescIndex;
			local jointDesc = self.attacherJoints[jointDescIndex];
			local inputJointDescIndex = implement.object.inputAttacherJointDescIndex;
			local moveDown = jointDesc.moveDown;
			if jointDescIndex == 1 then
				rearAttached = true;
				if jointDesc.moveDown then
					self.AParts.implement.isRaised = 0;
				else
					self.AParts.implement.isRaised = 1;
				end;
			end;
		end;
	end;
	if not rearAttached then
		self.AParts.implement.isRaised = 0.5;
	end;
	if self.AParts.implement.previousState ~= self.AParts.implement.isRaised then
		self.AParts.implement.reachedTarget = false;
	end;
	self.AParts.implement.previousState = self.AParts.implement.isRaised;

	local targetRotation = self.AParts.implement.rotMinX + self.AParts.implement.maxRot * self.AParts.implement.isRaised;
	if not self.AParts.implement.reachedTarget then
		if self.AParts.implement.currRotation < targetRotation then-- + self.AParts.implement.rotSpeed * 1.5 * dt then
			self.AParts.implement.currRotation = self.AParts.implement.currRotation + self.AParts.implement.rotSpeed * dt;
			if self.AParts.implement.currRotation > targetRotation then
				self.AParts.implement.reachedTarget = true;
			end;
		elseif self.AParts.implement.currRotation > targetRotation then -- - self.AParts.implement.rotSpeed * 1.5 * dt then
			self.AParts.implement.currRotation = self.AParts.implement.currRotation - self.AParts.implement.rotSpeed * dt;
			if self.AParts.implement.currRotation < targetRotation then
				self.AParts.implement.reachedTarget = true;
			end;
		end;
	end;
	
	setRotation(self.AParts.implement.node, self.AParts.implement.currRotation, 0, 0 );

	--front
	local frontAttached = false;
	for i=1, table.getn(self.attachedImplements) do
		local implement = self.attachedImplements[i];
		local object = implement.object;
		if object ~= nil then 
			local jointDescIndex = implement.jointDescIndex;
			local jointDesc = self.attacherJoints[jointDescIndex];
			local inputJointDescIndex = implement.object.inputAttacherJointDescIndex;
			local moveDown = jointDesc.moveDown;
			if jointDescIndex == 2 then
				frontAttached = true;
				if jointDesc.moveDown then
					self.AParts.implement1.isRaised = 0;
				else
					self.AParts.implement1.isRaised = 1;
				end;
			end;
		end;
	end;
	if not frontAttached then
		self.AParts.implement1.isRaised = 0.5;
	end;
	if self.AParts.implement1.previousState ~= self.AParts.implement1.isRaised then
		self.AParts.implement1.reachedTarget = false;
	end;
	self.AParts.implement1.previousState = self.AParts.implement1.isRaised;

	local targetRotation = self.AParts.implement1.rotMinX + self.AParts.implement1.maxRot * self.AParts.implement1.isRaised;
	if not self.AParts.implement1.reachedTarget then
		if self.AParts.implement1.currRotation < targetRotation then-- + self.AParts.implement1.rotSpeed * 1.5 * dt then
			self.AParts.implement1.currRotation = self.AParts.implement1.currRotation + self.AParts.implement1.rotSpeed * dt;
			if self.AParts.implement1.currRotation > targetRotation then
				self.AParts.implement1.reachedTarget = true;
			end;
		elseif self.AParts.implement1.currRotation > targetRotation then -- - self.AParts.implement1.rotSpeed * 1.5 * dt then
			self.AParts.implement1.currRotation = self.AParts.implement1.currRotation - self.AParts.implement1.rotSpeed * dt;
			if self.AParts.implement1.currRotation < targetRotation then
				self.AParts.implement1.reachedTarget = true;
			end;
		end;
	end;
	
	setRotation(self.AParts.implement1.node, self.AParts.implement1.currRotation, 0, 0 );
end;